//
//  Extractor.m
//  Style Extract
//
//  Created by Félix on 08-01-01.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Extractor.h"

@implementation Extractor
-(IBAction) extract: (id) sender
{
	NSMutableDictionary *dataPlist;
	NSDictionary *temporaryDict;
	NSString *themePath, *layoutPath;
	NSString *themeContentsPath, *layoutContentsPath;
	NSString *themeResourcePath, *layoutResourcePath;
	NSString *name = [text stringValue];
	
	dataPlist = [[NSMutableDictionary alloc] initWithContentsOfFile:
		[[NSBundle mainBundle] pathForResource: @"basic" ofType: @"plist"]];
		
	[dataPlist setObject: [NSString stringWithFormat: @"com.adiumx.%@", name] forKey: @"CFBundleIdentifier"];
	[dataPlist setObject: name forKey: @"CFBundleName"];
	
	// Theme
	themePath = [[[NSString alloc] initWithFormat: @"~/Desktop/%@.ListTheme", name] stringByExpandingTildeInPath];
	themeContentsPath = [themePath stringByAppendingString: @"/Contents"];
	themeResourcePath = [themeContentsPath stringByAppendingString: @"/Resources"];
	
	temporaryDict = [NSDictionary dictionaryWithContentsOfFile:
		[[NSString stringWithString: @"~/Library/Application Support/Adium 2.0/Users/Default/List Theme.plist"] stringByExpandingTildeInPath]];
	mkdir([themePath cStringUsingEncoding: NSASCIIStringEncoding], 0777);
	mkdir([themeContentsPath cStringUsingEncoding: NSASCIIStringEncoding], 0777);
	mkdir([themeResourcePath cStringUsingEncoding: NSASCIIStringEncoding], 0777);
	// I don't think we take a big risk with "atomically: NO" in this case
	[dataPlist writeToFile: [themeContentsPath stringByAppendingString: @"/Info.plist"] atomically: NO];
	[temporaryDict writeToFile: [themeResourcePath stringByAppendingString: @"/Data.plist"] atomically: NO];
	
	[temporaryDict release];
	
	// Layout
	layoutPath = [[[NSString alloc] initWithFormat: @"~/Desktop/%@.ListLayout", name] stringByExpandingTildeInPath];
	layoutContentsPath = [layoutPath stringByAppendingString: @"/Contents"];
	layoutResourcePath = [layoutContentsPath stringByAppendingString: @"/Resources"];
	
	temporaryDict = [NSDictionary dictionaryWithContentsOfFile:
		[[NSString stringWithString: @"~/Library/Application Support/Adium 2.0/Users/Default/List Layout.plist"] stringByExpandingTildeInPath]];
	mkdir([layoutPath cStringUsingEncoding: NSASCIIStringEncoding], 0777);
	mkdir([layoutContentsPath cStringUsingEncoding: NSASCIIStringEncoding], 0777);
	mkdir([layoutResourcePath cStringUsingEncoding: NSASCIIStringEncoding], 0777);
	[dataPlist writeToFile: [layoutContentsPath stringByAppendingString: @"/Info.plist"] atomically: NO];
	[temporaryDict writeToFile: [layoutResourcePath stringByAppendingString: @"/Data.plist"] atomically: NO];
	
	system("open ~/Desktop");
	
	exit(0);
}
@end
